% control_lsg6.m
% Aufgabe Kap. 5.6.6
% Regelung der stabilen PT$_2$-bertragungsfunktion

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Strecke definieren
a = 1 ; b = 0.5 ; c = 1 ; K = 1 ;
sys = ss([ -b/a -c/a ; 1 0 ],[K/a ; 0],[0 1],0) 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1. Streckenverhalten    
pole(sys)
[p,z] = pzmap(sys)
dcgain(sys)
[wn,z] = damp(sys) 

figure
    subplot(221) , step(sys) 
    subplot(222) , impulse(sys) 
    subplot(223) , bode(sys) 
    subplot(224) , pzmap(sys) 

ltiview(sys)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2. Regelung
P = tf([10],[1])                            % P-Regler
sys_P = feedback(P*tf(sys),1);              % Geregeltes System
pole(sys_P)
dcgain(sys_P)

PI = tf([10 1],[1 0])                       % PI-Regler
sys_PI = feedback(PI*tf(sys),1);            % Geregeltes System
pole(sys_PI)
dcgain(sys_PI)

PID = tf([5 10 1],[1 0])                    % PID-Regler
sys_PID = feedback(PID*tf(sys),1);          % Geregeltes System
pole(sys_PID)
dcgain(sys_PID)

figure
    subplot(311) , step(sys,'b-',sys_P,'r--',20)   , legend('Strecke','P-Regler',4)
    subplot(312) , step(sys,'b-',sys_PI,'r--',20)  , legend('Strecke','PI-Regler',4)
    subplot(313) , step(sys,'b-',sys_PID,'r--',20) , legend('Strecke','PID-Regler',4)

if exist('druck') == 1 , print('-depsc','lsg_stabil.eps') , end
if exist('druck') == 1 , print('-deps' ,'lsg_stabil_sw.eps') , end

figure
    subplot(311) , margin(P*tf(sys))   , legend('P-Regler',3)
    subplot(312) , margin(PI*tf(sys))  , legend('PI-Regler',3)
    subplot(313) , margin(PID*tf(sys)) , legend('PID-Regler',3)


set(gcf,'PaperPosition',[1 1 20 20])
if exist('druck') == 1 , print('-depsc','lsg_stabilmarg.eps') , end
if exist('druck') == 1 , print('-deps' ,'lsg_stabilmarg_sw.eps') , end
